<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import axios from "axios";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
var moment = require("moment");
@Component({
  components: {},
})
export default class FindTrackComponent extends Vue {
  orderCode: any = "";
  email: any = "";
  order:any = {};
  async onGetOrder(orderCode: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      const response = await this.$api.order.getMyOrder(
        this.email,
        orderCode,
        this.slug
      );
      if (response.data === null) {
        this.$router.push(
          `${this.slug ? `/${this.slug}` : ""}/pages/order-tracking`
        );
      } else {
        this.order = response.data;
                if (this.order?.listSelectedProductId?.length) {
          for (let item of this.order.listSelectedProductId) {
            let listVariant = {};
            if (item.listValue.length) {
              const listValue = item.listValue;
              const listOption = item.listOption || [];
              for (let val of listValue) {
                const findOption = listOption.find((elem: any) =>
                  elem.values.includes(val)
                );
                if (findOption) {
                  //@ts-ignore
                  listVariant[`${findOption.name}`] = val;
                }
              }
            }
            item["listVariant"] = listVariant;
          }
        }
        const listOrderTracking =
          //@ts-ignore
          JSON.parse(localStorage.getItem("listOrderTracking"));
        if (!listOrderTracking) {
          localStorage.setItem(
            "listOrderTracking",
            JSON.stringify([this.orderCode])
          );
        } else {
          let parseListOrderTracking = [...listOrderTracking, this.orderCode];
          parseListOrderTracking = this.$utils.uniq(parseListOrderTracking);
          localStorage.setItem(
            "listOrderTracking",
            //@ts-ignore
            JSON.stringify(parseListOrderTracking)
          );
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  convertImg(product: any) {
    if (product.imageUrl) {
      return `${api}/${product.imageUrl}`;
    }
    return "";
  }
  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  slug = "";
  mounted() {
    this.slug = this.$route.params.slug || "";
    const { order_code, email } = this.$route.query;
    if (order_code) {
      this.orderCode = order_code;
    }
    if (email) {
      this.email = email;
    }
    // @ts-ignore
    if (order_code) {
      this.onGetOrder(`#${this.$route.query.order_code}`);
    }
  }
}
</script>

<style lang="scss" scoped>
.main-fr {
  max-width: 1340px;
  width: 100%;
  h2 {
    font-size: clamp(16px, 1.5vw, 18px);
    line-height: 150%;
  }
  p {
    margin-bottom: 0;
  }

  .left-col {
    margin: 0 40px 0 auto;
    max-width: 450px;
    width: 100%;
    height: 100%;
  }
  .main-row {
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    margin-left: 0;
    max-width: 545px;
  }
  .first-row {
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    h3 {
      font-weight: 500;
      font-size: clamp(14px, 1.5vw, 18px);
      line-height: 150%;
    }
  }
  .circle {
    width: 32px;
    height: 32px;
    border-radius: 100%;
    background: #b5b5b5;
  }
  .circle-check {
    width: 32px;
    height: 32px;
    border-radius: 100%;
    background: #23d160;
  }
}
</style>
